##############################################################
# FileBundle
# Purpose: Used as a means of transferring files between
# server and clients.
# methods:
# - bundle
# - unbundle
# - add
##############################################################
require 'ftools'
class FileBundle
  def initialize(listOfFileThingys)
    @fileHash = Hash.new
    bundle(listOfFileThingys)
  end

  def bundle(listOfFileThingys)
    listOfFileThingys.each {|fileThingy|
      #@fileHash[filename] = File.readlines(filename).join
      add(fileThingy)
    }
  end

  def unbundle(relPath = nil)
    #File.mkpath(relPath) if relPath
    @fileHash.each { |filename,contents|
       path,fn = File.split(filename)
       path = relPath + "/" + path if relPath
       File.mkpath(path)
       fullname = "#{path}/#{fn}"
       puts "fullname is: #{fullname}" if $DEBUG
       File.open(fullname,"w+") { |file| file.write contents }
    }
  end

  def <<(filename)
    add(filename)
  end

  def add(file)
    case file
    when File
       unless File.directory?(file.path)
	  puts "path: #{file.path}"
          @fileHash[file.path] = file.readlines.join   
       end
    when String
       unless File.directory?(file)
          @fileHash[file] = File.readlines(file).join
       end
    end
  end

  
end #FileBundle

if __FILE__ == $0
  bundle = FileBundle.new(Dir["**/*"])
  todo = File.open("../drb_srvr.rb","r")
  #tmpdir = File.open("tmp","r")
  puts todo.path
  bundle << todo
  bundle << "TODO"
  bundle << "/etc/hosts"
  #bundle << tmpdir
  classStr = Marshal.dump(bundle)
  puts classStr.length
  #Dir.chdir("tmp")
  File.open("Bundle","w+"){ |file| file.write(classStr); puts file.type}
  bundle.unbundle("tmp1/mirror")
  b2 = FileBundle.new("tmp1/drb_srvr.rb")
  b2.unbundle("tmp")
end
