####################################################################
# Getter module
# defines the get_files method which can either copy design files
# from a path, or if the path is specified in the format: 
# 'ftp:<path>:user@machine:password' the design files will be retrieved
# via ftp.
# TODO: http support for getting files via http
# TODO: This file should be moved into the Distributor section
# since it really is related to Distributor.
#
# Phil Tomson   1/10/2002
####################################################################
# Copyright (C) 2002 Phil Tomson
# This file covered by the same license as Ruby's
####################################################################
module Getter
  require 'net/ftp'
  require 'ftools'
  def get_files(path,subDir=nil)
    @g_subDir=subDir
    @g_tp,@g_path,@g_user,@g_machine,@g_password = parse_uri(path)
    if $DEBUG
      puts "Getter::@g_tp = " + @g_tp.to_s
      puts "Getter::@g_path = \""+@g_path.to_s+"\""
      puts "Getter::@g_user = " + @g_user.to_s
      puts "Getter::@g_machine = "+ @g_machine.to_s
      puts "Getter::@g_password = "+@g_password.to_s
    end
    case @g_tp
       when /^ftp/
	 get_files_via_ftp
       when /^http/
	 raise RuntimeError, 'http: access not implemented yet'
       else
	 #assume it's a path on the local machine
	 get_files_via_copy
       end
  end

  def parse_uri(uri)
    tp = path = userAtMachine = optionalPassword = nil
    fieldVars = [:tp,:path,:userAtMachine,:optionalPassword]
    unless (uri =~ /(^ftp)|(^http)/i )
      fieldVars.shift
    end
    uri.split(/:/).each { |field|
      eval "#{fieldVars.shift} = #{\"field\"}"
    }
    user,machine = userAtMachine.split(/@/) if userAtMachine
    return tp,path,user||@g_user,machine||@g_machine,optionalPassword||@g_password
  end 

  def get_files_via_ftp
    ftp = Net::FTP.new(@g_machine,@g_user,@g_password) 
    ftp.debug_mode = true
    puts "ftp.chdir(./#{@g_path})"
    ftp.chdir(@g_path) 
    ftp.chdir("./"+@g_subDir) if @g_subDir
    fileList = ftp.list() 
      fileList.each { |file|
        next if file =~ /^total/ #wierdness returned from the list
        filename = file.split[-1]
        dir = true if file.split[0] =~ /^d/
        puts "filename is: "+filename if $DEBUG
        unless dir #NO recursion into subdirs yet!
          begin
            ftp.getbinaryfile(filename,filename,1024) 
          rescue Net::FTPPermError
            STDERR << "Couldn't get: #{filename} from: #@g_machine #@g_path"
          else
          end
        end #unless dir
      }
      ftp.close
  end

  def get_files_via_copy
    path = @g_path
    if @g_subDir
      path = "#@g_path/#@g_subDir"
    end
    Dir[path+"/*"].each{|file|
      begin
        puts "copying: #{file} to #{File.basename(file)}" if $DEBUG
        File.install(file, "./"+File.basename(file),0644)
      rescue 
        puts "WARNING: got an access error - results may be wrong!"
      ensure
      end
    }
  end

end #class Getter

if $0 == __FILE__
   include Getter
   Dir.chdir('tmp')
   get_files("ftp://pools/:pt@zeph:*****","pool1")
   get_files("/home/phill/rockit-0-3-8") 
   get_files("ftp://pools/","pool")
end
