#######################################################
# PiTask.rb
# Estimates pi using the Monte Carlo method
# more iterations should produce more accurate results
#######################################################
require "TaskMaster"
class PiTask
   include TaskMaster::Mixins::Runnable   
   
   def run(iterations)
     hits = 0
     puts "iterations = #{iterations} iterations.type = #{iterations.type}"
     iterations.times { |i|
       #pick a random x,y
       x = rand
       y = rand
       dist = Math.sqrt(x*x + y*y)
       if dist <= 1.0
         hits += 1
       end
     }
     @my_pi = 4*(hits.to_f/iterations.to_f)
     puts "PiTask::run finished -> estimated pi = #@my_pi"
   end

   def harvest
     return @my_pi
   end

end
if $0 == __FILE__
  iterations = 1000000
  findPI = PiTask.new()
  findPI.run(iterations)
  pi_est = findPI.harvest
  puts "pi estimate: #{pi_est}"
  puts Math::PI.to_s
end

