class SleepReporter
  def initialize(fileName = "SleepReport")
    @reportFile = File.new(fileName,"w+")
    @reportFile.sync = true #auto flush
    @reportFile.write("Report file for distributed_sleep example, started: #{Time.now.asctime}\n")
    @tasksRun = Hash.new(0) #keep track of the number of tasks each machine ran
  end

  # the 'report' method is required for reporters
  def report(machine,time,type)
    @reportFile.write("\n>>>a task of type: #{type} ran on #{machine} for #{time} seconds\n")
    @tasksRun[machine] += 1
  end

  # 'final_report' is an optional method to be called after the
  # distributor has distributed all tasks
  def final_report
    @reportFile.write("-----------------Summary ------------------\n")
    @tasksRun.each { |machine, number|
      @reportFile.write("#{machine} ran #{number} tasks\n")
    }
    @reportFile.write("Completed at: #{Time.now.asctime}\n")
    @reportFile.close
  end

end
