########################################################################
# SleepTask.rb
# A very simple demonstration of using TaskMaster::Distributor
# Notice how each of the classes in this file defines a 'run' method - 
# this makes them 'runnable'.  Objects which are 'runnable' by this definition
# can be distributed to clients by the Distributor 
# Also note that we mixin TaskMaster::Mixins::Runnable
########################################################################
require "TaskMaster"
class SleepTask
   include TaskMaster::Mixins::Runnable   
   def initialize(times = 5,sleeptime = 1)
      @times = times
      @sleeptime = sleeptime
      @taskTime = 0
   end
   
   def run(args=nil)
     #puts "string = #{string} string type is: #{string.type}"
      puts "args type is: #{args.type}"
      puts "SleepTask::Run - running #{args}"
      startTime = Time.now
      @times.times do
         print "."
         $stdout.flush
         sleep @sleeptime 
      end
      puts "\nSleepTask::Run - end #{args}\n\n"
      @taskTime =  Time.now - startTime
      return "OK"
   end

   def get_serverTimeLimit
      return ((@sleeptime +1) * @times)
   end

   def harvest
     return (Socket::gethostname), @taskTime, (self.type)
   end

end

#############################################################
# InitClass - used to demonstrate TaskMaster::Distributor#broadcast
# ###########################################################
class InitClass
   include TaskMaster::Mixins::Runnable   
   def initialize(message)
      @message = message
   end
   def run(*args)
      puts @message
      return "OK"
   end
end


