#########################################################################
# master.rb
# An example showing the use of TaskMaster for distributing
# SleepTask objects to a list of clients
#########################################################################
require 'getoptlong' #so we can use commandline args
require "../TM_finder"
require "TaskMaster"
opts = GetoptLong.new(
[ "--clients","-c",			GetoptLong::REQUIRED_ARGUMENT ],
[ "--ruby_ver","-v",			GetoptLong::REQUIRED_ARGUMENT ],
[ "--help","-h",		        GetoptLong::NO_ARGUMENT ]
)
ruby_ver = "1.6.4"
clientList = []
opts.each do |opt,arg|
  case opt
  when "--help","-h"
    puts "ruby master.rb <options>"
    puts "options are:"
    puts "\t--clients, -c : comma seperated list of clients"
    puts "\t--ruby_ver, -v: minimum Ruby version that client should have"
    puts "\t--help, -h    : displays this helpful message"
    exit
  when "--clients","-c"
    clientList = arg.split(/,/)
  when "--ruby_ver","-v"
    ruby_ver = arg
  else
    puts "invalid option: #{opt}"
    exit
  end
end

require "SleepReporter"
filesToRequire = ["SleepTask.rb"]
filesToRequire.each { |file|
   require file
}
reporter = SleepReporter.new
distributor = TaskMaster::Distributor.new(clientList)
distributor.remote_require(filesToRequire)
distributor.reporter = reporter
puts distributor.broadcast(InitClass.new("initializing!"))
list_of_tasks = []
20.times { |i|
   #just for variety sake:
   list_of_tasks <<  SleepTask.new()
} 

i = 0
list_of_tasks.each { |task|
   puts "sending #{task.type} number: #{i}" #{task.taskNum}"
   puts distributor.send_task(task,false)#," task# #{i}")   
   i += 1
}
distributor.wait
reporter.final_report
